import os.path
import sys
import numpy

sys.path.insert(0, os.path.join(os.path.dirname(__file__), ".."))
from viper import Viper, Mesh, Sphere, Polygon, VtkWindow
import viper

idtype = viper.get_vtk_idtype()

def _remove_tests(tests, n=1000):

    coordinates = numpy.array([[0,0,0], [1,0,0], [0,1,0]])
    coordinates2 = numpy.array([[0,0,0], [1,0,0], [0,1,0], [1,1,0]])
    nodes = numpy.array([[0,1,2]], dtype=idtype)
    nodes2 = numpy.array([[0,1,2], [1,2,3]], dtype=idtype)
    plotter = Viper([Mesh(coordinates, nodes), Mesh(coordinates2, nodes2)])
    win = VtkWindow(plotter)

    def add_and_remove(actors):
        for actor in actors:
            plotter.add_actor(actor)
        for actor in actors:
            plotter.remove_actor(actor)

    if 1 in tests:
        for i in xrange(n):
            spheres = [Sphere((0.5,0.5,0.0), 0.2, 30, 20, actor_kwds={"color":
                (1,0,0)}), Sphere((0.0,0.5,0.0), 0.2, 30, 20,
                    actor_kwds={"color": (1,0,0)})]
            add_and_remove(spheres)

    win.interactive()

    if 2 in tests:
        for i in xrange(n):
            add_and_remove([Polygon([(0,0,0), (1,1,0)]), Polygon([(1,1,0),
                (1,0,0)])])
    win.render()

    if 3 in tests:
        plotter.add_actor(Sphere((0.5,0.5,0.0), 0.2, 30, 20,
            actor_kwds={"color": (1,0,0)}))

    win.render()
    win.interactive()

def _clear_tests():
    vip = Viper([Polygon([(0,0,0), (1,1,0)], actor_kwds={"color": (1, 0, 0)}), Polygon([(1,1,0), (1,0,0)],
        actor_kwds={"color": (1, 0, 0)}), Sphere((0.5,0.5,0.0), 0.2, 30, 20,
            actor_kwds={"color": (1,0,0)})])
    win = VtkWindow(vip)
    win.interactive()
    vip.clear()
    win.render()
    win.interactive()

if __name__ == "__main__":
    _remove_tests([1,2,3])
    _clear_tests()
