"""Test changing scalar range."""
import sys
import os.path
import numpy
import time

sys.path.insert(0, os.path.join(os.path.dirname(__file__), ".."))
import viper

idtype = viper.get_vtk_idtype()

vertices = numpy.array([[0.0, 0.0, 0.0],
                        [1.0, 0.0, 0.0],
                        [0.0, 1.0, 0.0],
                        [1.0, 1.0, 0.0],
                        [2.0, 0.0, 0.0],
                        [0.0, 2.0, 0.0],
                        [2.0, 1.0, 0.0],
                        [1.0, 2.0, 0.0],
                        [2.0, 2.0, 0.0]])
cells = numpy.array([[0, 1, 2], [1, 2, 3], [1, 4, 3], [4, 3, 6], [2, 3, 5],
                        [3, 5, 7], [3, 6, 7], [6, 7, 8]], dtype=idtype)
scalars = numpy.linspace(0, 2, len(vertices))

viper.set_default_lut(os.path.join(os.path.dirname(viper.__file__), "data",
    "gauss_120.lut"))
field = viper.ScalarField(vertices, cells, scalars, scalar_range=(0, 0))
vip = viper.Viper([field])
win = viper.VtkWindow(vip)

# Increase the scalar range for a second
stop = 50
for i in xrange(stop):
    field.scalar_range = (field.scalar_range[0], field.scalar_range[1] + 2.0/stop)
    win.render()
    time.sleep(0.020)
win.interactive()
