"""Test _util module.
"""
from viper.tests._common import *

import sys
import os.path

import viper._util
import srllib.util

class MiscTest(TestCase):
    def test_resolve_path(self):
        """Test resolve_path function."""
        exe = sys.executable
        if srllib.util.get_os_name() != srllib.util.Os_Mac:
            self.assertEqual(viper._util.resolve_path(os.path.basename(exe)), exe)
        else:
            # The normal scheme typically fails on Mac, since the sys.exe
            # doesn't correspond to the commandline Python
            self.assertEqual(viper._util.resolve_path("open"), "/usr/bin/open")

    def test_resolve_error(self):
        """Test error handling of resolve_path function."""
        self._set_attr(os, "access", mock.FunctionMock(raises=OSError))
        self.assertRaises(viper._util.NotFound, viper._util.resolve_path,
                "python")

    def test_resolve_path_bad_path(self):
        """Test resolve_path with badly formed path."""
        exe = sys.executable
        self.assertRaises(ValueError, viper._util.resolve_path, os.path.abspath(exe))
