"""wxWidgets support.
"""
from __future__ import absolute_import
#from vtk.wx.wxVTKRenderWindow import wxVTKRenderWindow
from vtk.wx.wxVTKRenderWindowInteractor import wxVTKRenderWindowInteractor
import wx

from viper._common import WidgetBase


class Window(WidgetBase, wxVTKRenderWindowInteractor):
    """WX window for visualizing Viper renderings.

    We extend L{vtk.wx.wxVTKRenderWindow} by combining it with a Viper renderer.
    @ivar viper: Associated L{Viper<viper.Viper>}.
    """
    def __init__(self, vip, parent, size=None):
        """Constructor.
        @param vip: L{Viper<viper.Viper>} object.
        @param parent: Parent window.
        @param size: Optionally specify size as either a pair or a L{wx.Size}.
        """
        WidgetBase.__init__(self, vip)
        kwds = {}
        if size is not None:
            if not isinstance(size, wx.Size):
                size = wx.Size(*size)
            kwds["size"] = size
        wxVTKRenderWindowInteractor.__init__(self, parent, -1, **kwds)

        self.viper = vip
        self.GetRenderWindow().AddRenderer(vip.renderer)
